package b4a.makeblock;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (processBA == null) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.makeblock", "b4a.makeblock.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.makeblock", "b4a.makeblock.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.makeblock.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblstatus = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnconnect = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblmessage = null;
public anywheresoftware.b4a.objects.collections.Map _notes = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnstart = null;
public b4a.makeblock.starter _starter = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 29;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 30;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 31;BA.debugLine="notes.initialize";
mostCurrent._notes.Initialize();
 //BA.debugLineNum = 32;BA.debugLine="generateNotes";
_generatenotes();
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 57;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 36;BA.debugLine="SetState";
_setstate();
 //BA.debugLineNum = 37;BA.debugLine="End Sub";
return "";
}
public static String  _btnconnect_click() throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub btnConnect_Click";
 //BA.debugLineNum = 83;BA.debugLine="CallSub(Starter, \"Connect\")";
anywheresoftware.b4a.keywords.Common.CallSubNew(processBA,(Object)(mostCurrent._starter.getObject()),"Connect");
 //BA.debugLineNum = 84;BA.debugLine="End Sub";
return "";
}
public static void  _btnstart_click() throws Exception{
ResumableSub_btnStart_Click rsub = new ResumableSub_btnStart_Click(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_btnStart_Click extends BA.ResumableSub {
public ResumableSub_btnStart_Click(b4a.makeblock.main parent) {
this.parent = parent;
}
b4a.makeblock.main parent;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = -1;
 //BA.debugLineNum = 65;BA.debugLine="mkLeftLight(Colors.Red): Wait For Command_Complet";
_mkleftlight(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 65;BA.debugLine="mkLeftLight(Colors.Red): Wait For Command_Complet";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 1;
return;
case 1:
//C
this.state = -1;
;
 //BA.debugLineNum = 66;BA.debugLine="mkRightLight(Colors.Red): Wait For Command_Comple";
_mkrightlight(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 66;BA.debugLine="mkRightLight(Colors.Red): Wait For Command_Comple";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 2;
return;
case 2:
//C
this.state = -1;
;
 //BA.debugLineNum = 67;BA.debugLine="mkTone(notes.Get(\"C7\"), 2000): Wait For Command_C";
_mktone((int)(BA.ObjectToNumber(parent.mostCurrent._notes.Get((Object)("C7")))),(int) (2000));
 //BA.debugLineNum = 67;BA.debugLine="mkTone(notes.Get(\"C7\"), 2000): Wait For Command_C";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 3;
return;
case 3:
//C
this.state = -1;
;
 //BA.debugLineNum = 68;BA.debugLine="mkLeftLight(Colors.Green): Wait For Command_Compl";
_mkleftlight(anywheresoftware.b4a.keywords.Common.Colors.Green);
 //BA.debugLineNum = 68;BA.debugLine="mkLeftLight(Colors.Green): Wait For Command_Compl";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 4;
return;
case 4:
//C
this.state = -1;
;
 //BA.debugLineNum = 69;BA.debugLine="mkRightLight(Colors.Green): Wait For Command_Comp";
_mkrightlight(anywheresoftware.b4a.keywords.Common.Colors.Green);
 //BA.debugLineNum = 69;BA.debugLine="mkRightLight(Colors.Green): Wait For Command_Comp";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 5;
return;
case 5:
//C
this.state = -1;
;
 //BA.debugLineNum = 70;BA.debugLine="mkMainServo(90): Wait For Command_Complete: Sleep";
_mkmainservo((int) (90));
 //BA.debugLineNum = 70;BA.debugLine="mkMainServo(90): Wait For Command_Complete: Sleep";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 6;
return;
case 6:
//C
this.state = -1;
;
 //BA.debugLineNum = 70;BA.debugLine="mkMainServo(90): Wait For Command_Complete: Sleep";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (500));
this.state = 7;
return;
case 7:
//C
this.state = -1;
;
 //BA.debugLineNum = 71;BA.debugLine="mkMainServo(50): Wait For Command_Complete: Sleep";
_mkmainservo((int) (50));
 //BA.debugLineNum = 71;BA.debugLine="mkMainServo(50): Wait For Command_Complete: Sleep";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 8;
return;
case 8:
//C
this.state = -1;
;
 //BA.debugLineNum = 71;BA.debugLine="mkMainServo(50): Wait For Command_Complete: Sleep";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (500));
this.state = 9;
return;
case 9:
//C
this.state = -1;
;
 //BA.debugLineNum = 72;BA.debugLine="mkMainServo(130): Wait For Command_Complete: Slee";
_mkmainservo((int) (130));
 //BA.debugLineNum = 72;BA.debugLine="mkMainServo(130): Wait For Command_Complete: Slee";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 10;
return;
case 10:
//C
this.state = -1;
;
 //BA.debugLineNum = 72;BA.debugLine="mkMainServo(130): Wait For Command_Complete: Slee";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (500));
this.state = 11;
return;
case 11:
//C
this.state = -1;
;
 //BA.debugLineNum = 73;BA.debugLine="mkMainServo(90): Wait For Command_Complete: Sleep";
_mkmainservo((int) (90));
 //BA.debugLineNum = 73;BA.debugLine="mkMainServo(90): Wait For Command_Complete: Sleep";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 12;
return;
case 12:
//C
this.state = -1;
;
 //BA.debugLineNum = 73;BA.debugLine="mkMainServo(90): Wait For Command_Complete: Sleep";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (500));
this.state = 13;
return;
case 13:
//C
this.state = -1;
;
 //BA.debugLineNum = 74;BA.debugLine="mkForward(150): Wait For Command_Complete: Sleep(";
_mkforward((int) (150));
 //BA.debugLineNum = 74;BA.debugLine="mkForward(150): Wait For Command_Complete: Sleep(";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 14;
return;
case 14:
//C
this.state = -1;
;
 //BA.debugLineNum = 74;BA.debugLine="mkForward(150): Wait For Command_Complete: Sleep(";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (500));
this.state = 15;
return;
case 15:
//C
this.state = -1;
;
 //BA.debugLineNum = 75;BA.debugLine="mkTurnLeft(150): Wait For Command_Complete:	Sleep";
_mkturnleft((int) (150));
 //BA.debugLineNum = 75;BA.debugLine="mkTurnLeft(150): Wait For Command_Complete:	Sleep";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 16;
return;
case 16:
//C
this.state = -1;
;
 //BA.debugLineNum = 75;BA.debugLine="mkTurnLeft(150): Wait For Command_Complete:	Sleep";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (500));
this.state = 17;
return;
case 17:
//C
this.state = -1;
;
 //BA.debugLineNum = 76;BA.debugLine="mkBackward(150): Wait For Command_Complete: Sleep";
_mkbackward((int) (150));
 //BA.debugLineNum = 76;BA.debugLine="mkBackward(150): Wait For Command_Complete: Sleep";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 18;
return;
case 18:
//C
this.state = -1;
;
 //BA.debugLineNum = 76;BA.debugLine="mkBackward(150): Wait For Command_Complete: Sleep";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (500));
this.state = 19;
return;
case 19:
//C
this.state = -1;
;
 //BA.debugLineNum = 77;BA.debugLine="mkTurnRight(150): Wait For Command_Complete:	Slee";
_mkturnright((int) (150));
 //BA.debugLineNum = 77;BA.debugLine="mkTurnRight(150): Wait For Command_Complete:	Slee";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 20;
return;
case 20:
//C
this.state = -1;
;
 //BA.debugLineNum = 77;BA.debugLine="mkTurnRight(150): Wait For Command_Complete:	Slee";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (500));
this.state = 21;
return;
case 21:
//C
this.state = -1;
;
 //BA.debugLineNum = 78;BA.debugLine="mkStop: Wait For Command_Complete";
_mkstop();
 //BA.debugLineNum = 78;BA.debugLine="mkStop: Wait For Command_Complete";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 22;
return;
case 22:
//C
this.state = -1;
;
 //BA.debugLineNum = 79;BA.debugLine="mkTone(notes.Get(\"B1\"), 2000): Wait For Command_C";
_mktone((int)(BA.ObjectToNumber(parent.mostCurrent._notes.Get((Object)("B1")))),(int) (2000));
 //BA.debugLineNum = 79;BA.debugLine="mkTone(notes.Get(\"B1\"), 2000): Wait For Command_C";
anywheresoftware.b4a.keywords.Common.WaitFor("command_complete", processBA, this, null);
this.state = 23;
return;
case 23:
//C
this.state = -1;
;
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _command_complete() throws Exception{
}
public static String  _command() throws Exception{
 //BA.debugLineNum = 60;BA.debugLine="Sub Command()";
 //BA.debugLineNum = 61;BA.debugLine="CallSubDelayed(Me, \"Command_Complete\")";
anywheresoftware.b4a.keywords.Common.CallSubDelayed(processBA,main.getObject(),"Command_Complete");
 //BA.debugLineNum = 62;BA.debugLine="End Sub";
return "";
}
public static String  _generatenotes() throws Exception{
 //BA.debugLineNum = 186;BA.debugLine="Sub generateNotes()";
 //BA.debugLineNum = 187;BA.debugLine="notes.Put(\"B0\", 31)";
mostCurrent._notes.Put((Object)("B0"),(Object)(31));
 //BA.debugLineNum = 188;BA.debugLine="notes.Put(\"C1\", 33)";
mostCurrent._notes.Put((Object)("C1"),(Object)(33));
 //BA.debugLineNum = 189;BA.debugLine="notes.Put(\"D1\", 37)";
mostCurrent._notes.Put((Object)("D1"),(Object)(37));
 //BA.debugLineNum = 190;BA.debugLine="notes.Put(\"E1\", 41)";
mostCurrent._notes.Put((Object)("E1"),(Object)(41));
 //BA.debugLineNum = 191;BA.debugLine="notes.Put(\"F1\", 44)";
mostCurrent._notes.Put((Object)("F1"),(Object)(44));
 //BA.debugLineNum = 192;BA.debugLine="notes.Put(\"G1\", 49)";
mostCurrent._notes.Put((Object)("G1"),(Object)(49));
 //BA.debugLineNum = 193;BA.debugLine="notes.Put(\"A1\", 55)";
mostCurrent._notes.Put((Object)("A1"),(Object)(55));
 //BA.debugLineNum = 194;BA.debugLine="notes.Put(\"B1\", 62)";
mostCurrent._notes.Put((Object)("B1"),(Object)(62));
 //BA.debugLineNum = 195;BA.debugLine="notes.Put(\"C2\", 65)";
mostCurrent._notes.Put((Object)("C2"),(Object)(65));
 //BA.debugLineNum = 196;BA.debugLine="notes.Put(\"D2\", 73)";
mostCurrent._notes.Put((Object)("D2"),(Object)(73));
 //BA.debugLineNum = 197;BA.debugLine="notes.Put(\"E2\", 82)";
mostCurrent._notes.Put((Object)("E2"),(Object)(82));
 //BA.debugLineNum = 198;BA.debugLine="notes.Put(\"F2\", 87)";
mostCurrent._notes.Put((Object)("F2"),(Object)(87));
 //BA.debugLineNum = 199;BA.debugLine="notes.Put(\"G2\", 98)";
mostCurrent._notes.Put((Object)("G2"),(Object)(98));
 //BA.debugLineNum = 200;BA.debugLine="notes.Put(\"A2\", 110)";
mostCurrent._notes.Put((Object)("A2"),(Object)(110));
 //BA.debugLineNum = 201;BA.debugLine="notes.Put(\"B2\", 123)";
mostCurrent._notes.Put((Object)("B2"),(Object)(123));
 //BA.debugLineNum = 202;BA.debugLine="notes.Put(\"C3\", 131)";
mostCurrent._notes.Put((Object)("C3"),(Object)(131));
 //BA.debugLineNum = 203;BA.debugLine="notes.Put(\"D3\", 147)";
mostCurrent._notes.Put((Object)("D3"),(Object)(147));
 //BA.debugLineNum = 204;BA.debugLine="notes.Put(\"E3\", 165)";
mostCurrent._notes.Put((Object)("E3"),(Object)(165));
 //BA.debugLineNum = 205;BA.debugLine="notes.Put(\"F3\", 175)";
mostCurrent._notes.Put((Object)("F3"),(Object)(175));
 //BA.debugLineNum = 206;BA.debugLine="notes.Put(\"G3\", 196)";
mostCurrent._notes.Put((Object)("G3"),(Object)(196));
 //BA.debugLineNum = 207;BA.debugLine="notes.Put(\"A3\", 220)";
mostCurrent._notes.Put((Object)("A3"),(Object)(220));
 //BA.debugLineNum = 208;BA.debugLine="notes.Put(\"B3\", 247)";
mostCurrent._notes.Put((Object)("B3"),(Object)(247));
 //BA.debugLineNum = 209;BA.debugLine="notes.Put(\"C4\", 262)";
mostCurrent._notes.Put((Object)("C4"),(Object)(262));
 //BA.debugLineNum = 210;BA.debugLine="notes.Put(\"D4\", 294)";
mostCurrent._notes.Put((Object)("D4"),(Object)(294));
 //BA.debugLineNum = 211;BA.debugLine="notes.Put(\"E4\", 330)";
mostCurrent._notes.Put((Object)("E4"),(Object)(330));
 //BA.debugLineNum = 212;BA.debugLine="notes.Put(\"F4\", 349)";
mostCurrent._notes.Put((Object)("F4"),(Object)(349));
 //BA.debugLineNum = 213;BA.debugLine="notes.Put(\"G4\", 392)";
mostCurrent._notes.Put((Object)("G4"),(Object)(392));
 //BA.debugLineNum = 214;BA.debugLine="notes.Put(\"A4\", 440)";
mostCurrent._notes.Put((Object)("A4"),(Object)(440));
 //BA.debugLineNum = 215;BA.debugLine="notes.Put(\"B4\", 494)";
mostCurrent._notes.Put((Object)("B4"),(Object)(494));
 //BA.debugLineNum = 216;BA.debugLine="notes.Put(\"C5\", 523)";
mostCurrent._notes.Put((Object)("C5"),(Object)(523));
 //BA.debugLineNum = 217;BA.debugLine="notes.Put(\"D5\", 587)";
mostCurrent._notes.Put((Object)("D5"),(Object)(587));
 //BA.debugLineNum = 218;BA.debugLine="notes.Put(\"E5\", 659)";
mostCurrent._notes.Put((Object)("E5"),(Object)(659));
 //BA.debugLineNum = 219;BA.debugLine="notes.Put(\"F5\", 698)";
mostCurrent._notes.Put((Object)("F5"),(Object)(698));
 //BA.debugLineNum = 220;BA.debugLine="notes.Put(\"G5\", 784)";
mostCurrent._notes.Put((Object)("G5"),(Object)(784));
 //BA.debugLineNum = 221;BA.debugLine="notes.Put(\"A5\", 880)";
mostCurrent._notes.Put((Object)("A5"),(Object)(880));
 //BA.debugLineNum = 222;BA.debugLine="notes.Put(\"B5\", 988)";
mostCurrent._notes.Put((Object)("B5"),(Object)(988));
 //BA.debugLineNum = 223;BA.debugLine="notes.Put(\"C6\", 1047)";
mostCurrent._notes.Put((Object)("C6"),(Object)(1047));
 //BA.debugLineNum = 224;BA.debugLine="notes.Put(\"D6\", 1175)";
mostCurrent._notes.Put((Object)("D6"),(Object)(1175));
 //BA.debugLineNum = 225;BA.debugLine="notes.Put(\"E6\", 1319)";
mostCurrent._notes.Put((Object)("E6"),(Object)(1319));
 //BA.debugLineNum = 226;BA.debugLine="notes.Put(\"F6\", 1397)";
mostCurrent._notes.Put((Object)("F6"),(Object)(1397));
 //BA.debugLineNum = 227;BA.debugLine="notes.Put(\"G6\", 1568)";
mostCurrent._notes.Put((Object)("G6"),(Object)(1568));
 //BA.debugLineNum = 228;BA.debugLine="notes.Put(\"A6\", 1760)";
mostCurrent._notes.Put((Object)("A6"),(Object)(1760));
 //BA.debugLineNum = 229;BA.debugLine="notes.Put(\"B6\", 1976)";
mostCurrent._notes.Put((Object)("B6"),(Object)(1976));
 //BA.debugLineNum = 230;BA.debugLine="notes.Put(\"C7\", 2093)";
mostCurrent._notes.Put((Object)("C7"),(Object)(2093));
 //BA.debugLineNum = 231;BA.debugLine="notes.Put(\"D7\", 2349)";
mostCurrent._notes.Put((Object)("D7"),(Object)(2349));
 //BA.debugLineNum = 232;BA.debugLine="notes.Put(\"E7\", 2637)";
mostCurrent._notes.Put((Object)("E7"),(Object)(2637));
 //BA.debugLineNum = 233;BA.debugLine="notes.Put(\"F7\", 2794)";
mostCurrent._notes.Put((Object)("F7"),(Object)(2794));
 //BA.debugLineNum = 234;BA.debugLine="notes.Put(\"G7\", 3136)";
mostCurrent._notes.Put((Object)("G7"),(Object)(3136));
 //BA.debugLineNum = 235;BA.debugLine="notes.Put(\"A7\", 3520)";
mostCurrent._notes.Put((Object)("A7"),(Object)(3520));
 //BA.debugLineNum = 236;BA.debugLine="notes.Put(\"B7\", 3951)";
mostCurrent._notes.Put((Object)("B7"),(Object)(3951));
 //BA.debugLineNum = 237;BA.debugLine="notes.Put(\"C8\", 4186)";
mostCurrent._notes.Put((Object)("C8"),(Object)(4186));
 //BA.debugLineNum = 238;BA.debugLine="notes.Put(\"D8\", 4699)";
mostCurrent._notes.Put((Object)("D8"),(Object)(4699));
 //BA.debugLineNum = 239;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 22;BA.debugLine="Private lblStatus As Label";
mostCurrent._lblstatus = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Private btnConnect As Button";
mostCurrent._btnconnect = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 24;BA.debugLine="Private lblMessage As Label";
mostCurrent._lblmessage = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Dim notes As Map";
mostCurrent._notes = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 26;BA.debugLine="Private btnStart As Button";
mostCurrent._btnstart = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="End Sub";
return "";
}
public static String  _lblstatus_click() throws Exception{
 //BA.debugLineNum = 86;BA.debugLine="Sub lblStatus_Click";
 //BA.debugLineNum = 88;BA.debugLine="End Sub";
return "";
}
public static String  _messagefromdevice(String _msg) throws Exception{
 //BA.debugLineNum = 53;BA.debugLine="Public Sub MessageFromDevice(msg As String)";
 //BA.debugLineNum = 54;BA.debugLine="lblMessage.Text = msg";
mostCurrent._lblmessage.setText(BA.ObjectToCharSequence(_msg));
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return "";
}
public static String  _mkbackward(int _s) throws Exception{
String _cmd = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bc = null;
byte[] _b = null;
int _n = 0;
 //BA.debugLineNum = 133;BA.debugLine="Sub mkBackward(s As Int)";
 //BA.debugLineNum = 134;BA.debugLine="Dim cmd As String = \"ff550700020500000000\"";
_cmd = "ff550700020500000000";
 //BA.debugLineNum = 135;BA.debugLine="Dim bc As ByteConverter";
_bc = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 136;BA.debugLine="Dim b() As Byte = bc.HexToBytes(cmd)";
_b = _bc.HexToBytes(_cmd);
 //BA.debugLineNum = 137;BA.debugLine="Dim n As Int = b.Length";
_n = _b.length;
 //BA.debugLineNum = 138;BA.debugLine="b(n-3) = Bit.UnsignedShiftRight(Bit.And(s, 0xff00";
_b[(int) (_n-3)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_s,(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 139;BA.debugLine="b(n-4) = Bit.And(s, 0xff)";
_b[(int) (_n-4)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And(_s,(int) (0xff)));
 //BA.debugLineNum = 140;BA.debugLine="b(n-1) = Bit.UnsignedShiftRight(Bit.And(-s, 0xff0";
_b[(int) (_n-1)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And((int) (-_s),(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 141;BA.debugLine="b(n-2) = Bit.And(-s, 0xff)";
_b[(int) (_n-2)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (-_s),(int) (0xff)));
 //BA.debugLineNum = 142;BA.debugLine="CallSub2(Starter, \"SendMessage\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_b));
 //BA.debugLineNum = 143;BA.debugLine="End Sub";
return "";
}
public static String  _mkforward(int _s) throws Exception{
String _cmd = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bc = null;
byte[] _b = null;
int _n = 0;
 //BA.debugLineNum = 121;BA.debugLine="Sub mkForward(s As Int)";
 //BA.debugLineNum = 122;BA.debugLine="Dim cmd As String = \"ff550700020500000000\"";
_cmd = "ff550700020500000000";
 //BA.debugLineNum = 123;BA.debugLine="Dim bc As ByteConverter";
_bc = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 124;BA.debugLine="Dim b() As Byte = bc.HexToBytes(cmd)";
_b = _bc.HexToBytes(_cmd);
 //BA.debugLineNum = 125;BA.debugLine="Dim n As Int = b.Length";
_n = _b.length;
 //BA.debugLineNum = 126;BA.debugLine="b(n-3) = Bit.UnsignedShiftRight(Bit.And(-s, 0xff0";
_b[(int) (_n-3)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And((int) (-_s),(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 127;BA.debugLine="b(n-4) = Bit.And(-s, 0xff)";
_b[(int) (_n-4)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (-_s),(int) (0xff)));
 //BA.debugLineNum = 128;BA.debugLine="b(n-1) = Bit.UnsignedShiftRight(Bit.And(s, 0xff00";
_b[(int) (_n-1)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_s,(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 129;BA.debugLine="b(n-2) = Bit.And(s, 0xff)";
_b[(int) (_n-2)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And(_s,(int) (0xff)));
 //BA.debugLineNum = 130;BA.debugLine="CallSub2(Starter, \"SendMessage\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_b));
 //BA.debugLineNum = 131;BA.debugLine="End Sub";
return "";
}
public static String  _mkleftlight(int _c) throws Exception{
String _cmd = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bc = null;
byte[] _b = null;
int _n = 0;
 //BA.debugLineNum = 90;BA.debugLine="Sub mkLeftLight(c As Int)";
 //BA.debugLineNum = 91;BA.debugLine="Dim cmd As String = \"ff5509000208070202000000\"";
_cmd = "ff5509000208070202000000";
 //BA.debugLineNum = 92;BA.debugLine="Dim bc As ByteConverter";
_bc = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 93;BA.debugLine="Dim b() As Byte = bc.HexToBytes(cmd)";
_b = _bc.HexToBytes(_cmd);
 //BA.debugLineNum = 94;BA.debugLine="Dim n As Int = b.Length";
_n = _b.length;
 //BA.debugLineNum = 95;BA.debugLine="b(n-3) = Bit.UnsignedShiftRight(Bit.And(c, 0xff00";
_b[(int) (_n-3)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_c,(int) (0xff0000)),(int) (16)));
 //BA.debugLineNum = 96;BA.debugLine="b(n-2) = Bit.UnsignedShiftRight(Bit.And(c, 0xff00";
_b[(int) (_n-2)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_c,(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 97;BA.debugLine="b(n-1) = Bit.And(c, 0xff)";
_b[(int) (_n-1)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And(_c,(int) (0xff)));
 //BA.debugLineNum = 98;BA.debugLine="CallSub2(Starter, \"SendMessage\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_b));
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
return "";
}
public static String  _mkmainservo(int _a) throws Exception{
String _cmd = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bc = null;
byte[] _b = null;
int _n = 0;
 //BA.debugLineNum = 112;BA.debugLine="Sub mkMainServo(a As Int)";
 //BA.debugLineNum = 113;BA.debugLine="Dim cmd As String = \"ff550600020b04025a\"";
_cmd = "ff550600020b04025a";
 //BA.debugLineNum = 114;BA.debugLine="Dim bc As ByteConverter";
_bc = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 115;BA.debugLine="Dim b() As Byte = bc.HexToBytes(cmd)";
_b = _bc.HexToBytes(_cmd);
 //BA.debugLineNum = 116;BA.debugLine="Dim n As Int = b.Length";
_n = _b.length;
 //BA.debugLineNum = 117;BA.debugLine="b(n-1) = Bit.And(a, 0xff)";
_b[(int) (_n-1)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And(_a,(int) (0xff)));
 //BA.debugLineNum = 118;BA.debugLine="CallSub2(Starter, \"SendMessage\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_b));
 //BA.debugLineNum = 119;BA.debugLine="End Sub";
return "";
}
public static String  _mkrightlight(int _c) throws Exception{
String _cmd = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bc = null;
byte[] _b = null;
int _n = 0;
 //BA.debugLineNum = 101;BA.debugLine="Sub mkRightLight(c As Int)";
 //BA.debugLineNum = 102;BA.debugLine="Dim cmd As String = \"ff5509000208070201000000\"";
_cmd = "ff5509000208070201000000";
 //BA.debugLineNum = 103;BA.debugLine="Dim bc As ByteConverter";
_bc = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 104;BA.debugLine="Dim b() As Byte = bc.HexToBytes(cmd)";
_b = _bc.HexToBytes(_cmd);
 //BA.debugLineNum = 105;BA.debugLine="Dim n As Int = b.Length";
_n = _b.length;
 //BA.debugLineNum = 106;BA.debugLine="b(n-3) = Bit.UnsignedShiftRight(Bit.And(c, 0xff00";
_b[(int) (_n-3)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_c,(int) (0xff0000)),(int) (16)));
 //BA.debugLineNum = 107;BA.debugLine="b(n-2) = Bit.UnsignedShiftRight(Bit.And(c, 0xff00";
_b[(int) (_n-2)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_c,(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 108;BA.debugLine="b(n-1) = Bit.And(c, 0xff)";
_b[(int) (_n-1)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And(_c,(int) (0xff)));
 //BA.debugLineNum = 109;BA.debugLine="CallSub2(Starter, \"SendMessage\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_b));
 //BA.debugLineNum = 110;BA.debugLine="End Sub";
return "";
}
public static String  _mkstop() throws Exception{
 //BA.debugLineNum = 169;BA.debugLine="Sub mkStop()";
 //BA.debugLineNum = 170;BA.debugLine="mkForward(0)";
_mkforward((int) (0));
 //BA.debugLineNum = 171;BA.debugLine="End Sub";
return "";
}
public static String  _mktone(int _f,int _d) throws Exception{
String _cmd = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bc = null;
byte[] _b = null;
int _n = 0;
 //BA.debugLineNum = 173;BA.debugLine="Sub mkTone(f As Int, d As Int)";
 //BA.debugLineNum = 174;BA.debugLine="d = d / 2";
_d = (int) (_d/(double)2);
 //BA.debugLineNum = 175;BA.debugLine="Dim cmd As String = \"ff550700022200000000\"";
_cmd = "ff550700022200000000";
 //BA.debugLineNum = 176;BA.debugLine="Dim bc As ByteConverter";
_bc = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 177;BA.debugLine="Dim b() As Byte = bc.HexToBytes(cmd)";
_b = _bc.HexToBytes(_cmd);
 //BA.debugLineNum = 178;BA.debugLine="Dim n As Int = b.Length";
_n = _b.length;
 //BA.debugLineNum = 179;BA.debugLine="b(n-3) = Bit.UnsignedShiftRight(Bit.And(f, 0xff00";
_b[(int) (_n-3)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_f,(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 180;BA.debugLine="b(n-4) = Bit.And(f, 0xff)";
_b[(int) (_n-4)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And(_f,(int) (0xff)));
 //BA.debugLineNum = 181;BA.debugLine="b(n-1) = Bit.UnsignedShiftRight(Bit.And(d, 0xff00";
_b[(int) (_n-1)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_d,(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 182;BA.debugLine="b(n-2) = Bit.And(d, 0xff)";
_b[(int) (_n-2)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And(_d,(int) (0xff)));
 //BA.debugLineNum = 183;BA.debugLine="CallSub2(Starter, \"SendMessage\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_b));
 //BA.debugLineNum = 184;BA.debugLine="End Sub";
return "";
}
public static String  _mkturnleft(int _s) throws Exception{
String _cmd = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bc = null;
byte[] _b = null;
int _n = 0;
 //BA.debugLineNum = 145;BA.debugLine="Sub mkTurnLeft(s As Int)";
 //BA.debugLineNum = 146;BA.debugLine="Dim cmd As String = \"ff550700020500000000\"";
_cmd = "ff550700020500000000";
 //BA.debugLineNum = 147;BA.debugLine="Dim bc As ByteConverter";
_bc = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 148;BA.debugLine="Dim b() As Byte = bc.HexToBytes(cmd)";
_b = _bc.HexToBytes(_cmd);
 //BA.debugLineNum = 149;BA.debugLine="Dim n As Int = b.Length";
_n = _b.length;
 //BA.debugLineNum = 150;BA.debugLine="b(n-3) = Bit.UnsignedShiftRight(Bit.And(s, 0xff00";
_b[(int) (_n-3)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_s,(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 151;BA.debugLine="b(n-4) = Bit.And(s, 0xff)";
_b[(int) (_n-4)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And(_s,(int) (0xff)));
 //BA.debugLineNum = 152;BA.debugLine="b(n-1) = Bit.UnsignedShiftRight(Bit.And(s, 0xff00";
_b[(int) (_n-1)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_s,(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 153;BA.debugLine="b(n-2) = Bit.And(s, 0xff)";
_b[(int) (_n-2)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And(_s,(int) (0xff)));
 //BA.debugLineNum = 154;BA.debugLine="CallSub2(Starter, \"SendMessage\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_b));
 //BA.debugLineNum = 155;BA.debugLine="End Sub";
return "";
}
public static String  _mkturnright(int _s) throws Exception{
String _cmd = "";
anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bc = null;
byte[] _b = null;
int _n = 0;
 //BA.debugLineNum = 157;BA.debugLine="Sub mkTurnRight(s As Int)";
 //BA.debugLineNum = 158;BA.debugLine="Dim cmd As String = \"ff550700020500000000\"";
_cmd = "ff550700020500000000";
 //BA.debugLineNum = 159;BA.debugLine="Dim bc As ByteConverter";
_bc = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 160;BA.debugLine="Dim b() As Byte = bc.HexToBytes(cmd)";
_b = _bc.HexToBytes(_cmd);
 //BA.debugLineNum = 161;BA.debugLine="Dim n As Int = b.Length";
_n = _b.length;
 //BA.debugLineNum = 162;BA.debugLine="b(n-3) = Bit.UnsignedShiftRight(Bit.And(-s, 0xff0";
_b[(int) (_n-3)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And((int) (-_s),(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 163;BA.debugLine="b(n-4) = Bit.And(-s, 0xff)";
_b[(int) (_n-4)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (-_s),(int) (0xff)));
 //BA.debugLineNum = 164;BA.debugLine="b(n-1) = Bit.UnsignedShiftRight(Bit.And(-s, 0xff0";
_b[(int) (_n-1)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And((int) (-_s),(int) (0xff00)),(int) (8)));
 //BA.debugLineNum = 165;BA.debugLine="b(n-2) = Bit.And(-s, 0xff)";
_b[(int) (_n-2)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (-_s),(int) (0xff)));
 //BA.debugLineNum = 166;BA.debugLine="CallSub2(Starter, \"SendMessage\", b)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._starter.getObject()),"SendMessage",(Object)(_b));
 //BA.debugLineNum = 167;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _setstate() throws Exception{
String _status = "";
 //BA.debugLineNum = 39;BA.debugLine="Public Sub SetState";
 //BA.debugLineNum = 40;BA.debugLine="btnStart.Enabled = Starter.connected";
mostCurrent._btnstart.setEnabled(mostCurrent._starter._connected);
 //BA.debugLineNum = 41;BA.debugLine="btnConnect.Enabled = Not(Starter.connected)";
mostCurrent._btnconnect.setEnabled(anywheresoftware.b4a.keywords.Common.Not(mostCurrent._starter._connected));
 //BA.debugLineNum = 42;BA.debugLine="Dim status As String";
_status = "";
 //BA.debugLineNum = 43;BA.debugLine="If Starter.connected Then";
if (mostCurrent._starter._connected) { 
 //BA.debugLineNum = 44;BA.debugLine="status = \"connected\"";
_status = "connected";
 }else if(mostCurrent._starter._connecting) { 
 //BA.debugLineNum = 46;BA.debugLine="status = \"trying to connect...\"";
_status = "trying to connect...";
 }else {
 //BA.debugLineNum = 48;BA.debugLine="status = \"disconnected\"";
_status = "disconnected";
 };
 //BA.debugLineNum = 50;BA.debugLine="lblStatus.Text = $\"Status: ${status}\"$";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence(("Status: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_status))+"")));
 //BA.debugLineNum = 51;BA.debugLine="End Sub";
return "";
}
}
